/**
 * <copyright>
 * </copyright>
 *
 * $Id: ValidatorReference.java 6925 2010-11-29 17:43:40Z michael_clay $
 */
package org.openxma.dsl.core.model;

import java.sql.Timestamp;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Validator Reference</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.openxma.dsl.core.model.ValidatorReference#getValidator <em>Validator</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.openxma.dsl.core.CorePackage#getValidatorReference()
 * @model
 * @generated
 */
@SuppressWarnings("serial")
public interface ValidatorReference extends ReferenceWithParameter {
	/**
	 * @generated NOT
	 */
	static final String I18N_ENUMERATION_VALIDATOR = "I18NEnumerationValidator";
	static final String CUSTOM_VALIDATOR = "CustomValidator";
	static final String TIME_STAMP_VALIDATOR = "TimeStampValidator";
	static final String DATE_VALIDATOR = "DateValidator";
	static final String BOOLEAN_VALIDATOR = "BooleanValidator";
	static final String NUMBER_VALIDATOR = "NumberValidator";
	static final String STRING_VALIDATOR = "StringValidator";
	public static final Map<String, String> VALIDATOR_2_TYPE_MAPPING = new HashMap<String, String>() {
		{
			put(STRING_VALIDATOR, String.class.getSimpleName());
			put(NUMBER_VALIDATOR, Number.class.getSimpleName());
			put(BOOLEAN_VALIDATOR, Boolean.class.getSimpleName());
			put(DATE_VALIDATOR, Date.class.getSimpleName());
			put(TIME_STAMP_VALIDATOR, Timestamp.class.getSimpleName());
			put(I18N_ENUMERATION_VALIDATOR, String.class.getSimpleName());
		}
	};

	/**
	 * Returns the value of the '<em><b>Validator</b></em>' reference. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Validator</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Validator</em>' reference.
	 * @see #setValidator(Validator)
	 * @see org.openxma.dsl.core.CorePackage#getValidatorReference_Validator()
	 * @model
	 * @generated
	 */
	Validator getValidator();

	/**
	 * Sets the value of the '
	 * {@link org.openxma.dsl.core.model.ValidatorReference#getValidator
	 * <em>Validator</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Validator</em>' reference.
	 * @see #getValidator()
	 * @generated
	 */
	void setValidator(Validator value);

	/**
	 * 
	 * @modified
	 * @return
	 */
	public ValidatorReference getRootValidatorReference();
	
	/**
	 * 
	 * @modified
	 * @return
	 */
	boolean isStringValidator();

	/**
	 * 
	 * @modified
	 * @return
	 */
	boolean isCustomValidator();
	/**
	 * 
	 * @modified
	 * @return
	 */
	boolean isNumberValidator();
	/**
	 * 
	 * @modified
	 * @return
	 */
	boolean isUserDefinedValidator();
	/**
	 * 
	 * @modified
	 * @return
	 */
	boolean isDateValidator();
	
	/**
	 * 
	 * @modified
	 * @return
	 */
	boolean isTimeStampValidator();
	
	/**
     * 
     * @modified
     * @return
     */
    boolean isBooleanValidator();
    
    /**
     * 
     * @modified
     * @return
     */
    boolean isI18nValidator();

} // ValidatorReference
